/******************************************************************************
 * (c) 2018 Microchip Technology Inc.Ǝq
 *
 * ̏̏ƂāAMicrochipĳƉ̔hMicrochipi
 * ɌĎgp邱Ƃł܂BMicrochipĳ𔺂Ȃ(J 
 * ĳ܂)Oҿĳ̎gpɓKpO҂̋炷̂͂
 * ̐ӔCłB
 *
 * ̿ĳMicrochip"󂻂̂܂"ɂċ܂BNQAiA
 * ړIւ̓K̂ǂ̈Öق̕ۏ؂܂߁AIAÎI܂͖@߂ł낤
 * ̿ĳɂ͓Kp܂BႦMicrochip\iꂽAQ\
 * ƂĂA̔@Ɋւ炸A@ȂꍇłMicrochipͿĳɊ֘A
 * @Ȃނ̊ԐړIAʁAIAI܂͕KRIȑAQAp
 * ͎x̐ӔC𕉂܂B@ɂċő͈̔͂܂ŁA̿ĳ
 * Ɋ֘Aǂ̕@ł̑SɉĂAmicrochip̑ӔCźA΁A
 * Ȃ̿ĳɑ΂Microchip֒ڎxp̊z𒴂܂B
 *
 *****************************************************************************/

/*
 * tinyAVR 01nymegaAVR 0npTWI/I2Cް۰
 * TWIu͏]u\ݒŁATWI/I2C呕uް󂯎܂B
 * 呕ȗe޲Ă͎MmF̂ߏ]uɂđԂ܂B
 *
 * ݽ׸̈ɒuׂް۰ނɂĂToolchain->AVR/GNU Linker->General
 * ŕWņق֎~邱ƂKvłB
 *
 * ̗͈ȉݔzuATtiny817pɏĂ܂B
 * TWI0 SCL   PA2
 * TWI0 SDA   PA1
 * LED0       PB4
 * SW1        PC5 (Oٱ)
 */
#define F_CPU_RESET                 (20E6/6)

#include <avr/io.h>
#include <stdbool.h>
#include "i2c_slave.h"

/* ؍\ݒ
 * BOOTEND_FUSE~256ް۰ ۸ ؎gpʈȏłȂ΂Ȃ܂B
 * ͍œK-O3490޲ĂŁÂBOOTEND_FUSE = 0x02łB
 */
#define BOOTEND_FUSE                (0x02)
#define BOOT_SIZE                   (BOOTEND_FUSE * 0x100)
#define MAPPED_APPLICATION_START    (MAPPED_PROGMEM_START + BOOT_SIZE)
#define MAPPED_APPLICATION_SIZE     (MAPPED_PROGMEM_SIZE - BOOT_SIZE)

/* ˭ލ\ݒ
 * BOOTEND256޲Ẳްė̈̑傫(Ō+1)ݒ肵܂B
 * APPEND = 0x00͉pނƂBOOTEND~256ׯ̍Ō܂ł`܂B
 * c˭ނ͊`Ԑݒ܂B
 */
FUSES = {
	.OSCCFG = FREQSEL_20MHZ_gc,
	.SYSCFG0 = CRCSRC_NOCRC_gc | RSTPINCFG_UPDI_gc,
	.SYSCFG1 = SUT_64MS_gc,
	.APPEND = 0x00,
	.BOOTEND = BOOTEND_FUSE
};

/* p߲^` */
typedef void (*const app_t)(void);

/* ̪֐^ */
static bool is_bootloader_requested(void);
static void init_twi(void);
static uint8_t twi_receive(void);
static void twi_send(uint8_t byte);
static void init_status_led(void);
static void toggle_status_led(void);

/*
 * ްĊ֐
 * ׯߖ񂷂邽߂ɺݽ׸̈(.ctors)ɒuĂB
 * ֐۰ނƴ۰ނsgp̂ߗ̑gp܂B
 */
__attribute__((naked)) __attribute__((section(".ctors"))) void boot(void)
{
	/* AVR GCCxAR1=0Ӑ}悤ɼт */
	asm volatile("clr r1");

	/* pڍsA܂ް۰ތp𒲍 */
	if(!is_bootloader_requested()) {
		/* ްė̈{ */
		NVMCTRL.CTRLB = NVMCTRL_BOOTLOCK_bm;

		/* ްė̈撼ɔzu鉞p֍sB */
		app_t app = (app_t)(BOOT_SIZE / sizeof(app_t));
		app();
	}

	/* ʐM̪ */
	init_twi();
	init_status_led();

	/*
	 * p̈̐擪۸ݸ()Jn
	 * 傫ׯeʂł̈邽߂̏MAPPED_PROGMEM_STARTZ
	 */
	uint8_t *app_ptr = (uint8_t *)MAPPED_APPLICATION_START;
	while(app_ptr - MAPPED_PROGMEM_START <= (uint8_t *)PROGMEM_END) {
		/* M؂ɐݒ肷Oް𑗂Ԃ */
		uint8_t rx_data = twi_receive();
		twi_send(rx_data);

		/* ׯɏOɈʒuI߰ފɏՕ֐ݒ */
		*app_ptr = rx_data;
		app_ptr++;
		if(!((uint16_t)app_ptr % MAPPED_PROGMEM_PAGE_SIZE)) {
			/* ߰ދEBA߰ނׯɈn() */
			_PROTECTED_WRITE_SPM(NVMCTRL.CTRLA, NVMCTRL_CMD_PAGEERASEWRITE_gc);
			while(NVMCTRL.STATUS & NVMCTRL_FBUSY_bm);

			toggle_status_led();
		}
	}

	/*  ؾĔs */
	_PROTECTED_WRITE(RSTCTRL.SWRR, RSTCTRL_SWRE_bm);
}

/*
 * ް v֐
 */
static bool is_bootloader_requested(void)
{
	/* SW1 (PC5)Low */
	if(VPORTC.IN & PIN5_bm) {
		return false;
	}
	return true;
}

/*
 * ʐM̪֐
 */
static void init_twi(void)
{
	/* ݂݈ʒuɐ؂ւ */
	PORTMUX.CTRLB |= PORTMUX_TWI0_ALTERNATE_gc;

	/* TWIײދ */
	i2c_slave_init();
}

static uint8_t twi_receive(void)
{
	/* M߰ݸ */
	i2c_driver.result = I2C_RESULT_WAITING;
	while(i2c_driver.result != I2C_RESULT_OK) {
		i2c_slave_isr();
	}

	return i2c_driver.received_data[0];
}

static void twi_send(uint8_t byte)
{
	i2c_driver.send_data[0] = byte;

	/* M߰ݸ */
	i2c_driver.result = I2C_RESULT_WAITING;
	while(i2c_driver.result != I2C_RESULT_OK) {
		i2c_slave_isr();
	}
}

static void init_status_led(void)
{
	/* LED0(PB4)o͂ƂĐݒ */
	VPORTB.DIR |= PIN4_bm;
}

static void toggle_status_led(void)
{
	/* LED0(PB4)ݐ؂ւ */
	VPORTB.OUT ^= PIN4_bm;
}
